/**************************************************************************************
 *                                                                                    *
 * This application contains code from OpenDivX and is released as a "Larger Work"    *
 * under that license. Consistant with that license, this application is released     *
 * under the GNU General Public License.                                              *
 *                                                                                    *
 * The OpenDivX license can be found at: http://www.projectmayo.com/opendivx/docs.php *
 * The GPL can be found at: http://www.gnu.org/copyleft/gpl.html                      *
 *                                                                                    *
 * Copyright (c) 2001 - Project Mayo                                                  *
 *                                                                                    *
 * Authors: Damien Chavarria <adrc at projectmayo.com>                                *
 *                                                                                    *
 **************************************************************************************/

#ifndef CODEC_H
#define CODEC_H

#include <stdio.h>
#include <io.h>
#include <windows.h>
#include <vfw.h>

#include "debug.h"

class Codec {

private:

	HIC        hic;
	BITMAPINFO in_bih;
	BITMAPINFO out_bih;

public:

	Codec(BITMAPINFOHEADER *bih);
	~Codec();

	int IsOK();

	int Decompress(char *in, long in_size, char *out);
	int Drop(char *in, long in_size, char *out);
	
	int Close();

};

#endif
