/**************************************************************************************
 *                                                                                    *
 * This application contains code from OpenDivX and is released as a "Larger Work"    *
 * under that license. Consistant with that license, this application is released     *
 * under the GNU General Public License.                                              *
 *                                                                                    *
 * The OpenDivX license can be found at: http://www.projectmayo.com/opendivx/docs.php *
 * The GPL can be found at: http://www.gnu.org/copyleft/gpl.html                      *
 *                                                                                    *
 * Copyright (c) 2001 - Project Mayo                                                  *
 *                                                                                    *
 * Authors: Damien Chavarria <adrc at projectmayo.com>                                *
 *                                                                                    *
 **************************************************************************************/


#include "Playback.h"

#include <windows.h>
#include <stdio.h>
#include "../build/win32/resource.h"

/*
 * ENUMS for ACTIONS
 *
 */

enum {

	ACTION_NONE,
	ACTION_CLOSE,
	ACTION_MINIMIZE,
	ACTION_MENU,
	ACTION_REWIND,
	ACTION_STOP,
	ACTION_PLAY,
	ACTION_PAUSE,
	ACTION_FORWARD,
	ACTION_LOAD,
	ACTION_MOVING,
	ACTION_RESIZE,
	ACTION_VOLUME_BAR,
	ACTION_VOLUME_CURSOR,
	ACTION_PROGRESS_BAR,
	ACTION_PROGRESS_CURSOR
};

/*
 * Skin Class, load and 
 * display skin into window.
 *
 */

class Skin {

private:

	HWND    hwnd;

	HBITMAP skin;
	HBITMAP controls;
	HBITMAP logo;

	RECT    menuButton;
	RECT    minimizeButton;
	RECT    closeButton;
	RECT    rewindButton;
	RECT    stopButton;
	RECT    playButton;
	RECT    pauseButton;
	RECT    forwardButton;
	RECT    loadButton;
	RECT    resizeButton;

	RECT    progressBar;
	RECT    progressCursor;
	RECT    volumeBar;
	RECT    volumeCursor;
		
	BOOL isInsideRect(int x, int y, RECT rect);

	int SetVolume(HWND hwnd, int volume);
	int SetProgress(HWND hwnd, double progress);

public:

	/*
	 * From 0 to 100
	 */

	int volume;
	double progress;

	Skin(HINSTANCE hIstance);
	~Skin();

	int DefaultWidth();
	int DefaultHeight();

	int GetProgress();
	int GetVolume();

	int Display(HWND hwnd, Playback *playback);
	int UpdateSize(HWND hwnd);

	int SetVolumeCursorX(HWND hwnd, int x);
	int SetProgressCursorX(HWND hwnd, int x);
	int SetProgressValue(HWND hwnd, double progress);

	int SetActionStart(HWND hwnd, int action);
	int SetActionEnd(HWND hwnd, int action);

	int DisplayFps(HWND hwnd, Playback *playback);

	int GetAction(int x, int y);
};
